// ==UserScript==
// @include http://109.235.54.176/*
// @include http://grooveshark.com/*
// ==/UserScript==

//SciLorsGrooveUnlocker

if (typeof SciLorsGrooveUnlocker == "undefined") {
  var SciLorsGrooveUnlocker = new function() {  
	/* All files that are needed from the local file system */
	var files = new Array("GrooveFix.xml", "sidebar.html", "grooveshark.html", "initiateSession.json", "GrooveIcon128.base64");
	var groovesharkIp = "http://109.235.54.176";
	var downloadGrooveshark = true;

	var fileData = new Object();
	/* Opera specific config (for version) */
	var operaConfig = "../config.xml";
	var chromeConfig = "../manifest.json";
	var firefoxConfig = "firefoxVersion";

	/* Variables for fetching the Grooveshark(tm) session */
	var uuid = guidGenerator().toUpperCase();
	var sessionUrl = "http://grooveshark.com/more.php?initiateSession";
	
	var loaded = false;

	/* Browser detection */
	function isChrome() {
		try {
			if (chrome) {
				return true;
			}
		} catch (ex) { }
		return false;
	}
	function isOpera() {
		try {
			if (opera) {
				return true;
			}
		} catch (ex) { }
		return false;
	}
	function isFirefox() {
		try {
			if (getAppContent()) {
				return true;
			}
		} catch (ex) { }
		return false;
	}

	function getAppContent() {
		var appcontent = document.getElementById("appcontent"); // Firefox
		if (!appcontent) {
			appcontent = document.getElementById("browsers"); // Fennec
		}
		return appcontent;
	}
	function getDocument() {
		if (isFirefox()) {
			return content.document;
		}
		return document;
	}

	/* Document Manipulation */
	function overwriteHtml(body) {
		var sidebar = getSciLorSidebar();
		if (isFirefox()) {
			getDocument().documentElement.setAttribute("htm", body);
			getDocument().documentElement.setAttribute("sideba", sidebar);
			var url = "javascript:(function(){" + 
				"var x=content.document.documentElement.getAttribute('htm');" + 
				"var y=content.document.documentElement.getAttribute('sideba');" + 
				"document.open();document.write(x);document.close();" + 
				"document.getElementById('capitalSidebar').innerHTML = y;" +
				"})();";
			getDocument().location.href = url;
			//getDocument().documentElement.setAttribute("sideba", sidebar);
			//resetSidebar();

			/*
			getDocument().body.innerHTML = body;
			getDocument().getElementById("capitalSidebar").innerHTML = sidebar;
			//var newWindow = window.open('data:text/html;charset=utf-8,' + encodeURI(replaceAds(body)), '_blank', 'height=500, width=500');
			netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect")  //Do not use, deprecated!
			var ww = Components.classes[
				"@mozilla.org/embedcomp/window-watcher;1"].
				getService(Components.interfaces.nsIWindowWatcher);
			popupWindow = ww.openWindow(null, 'data:text/html;charset=utf-8,' + encodeURI(replaceAds(body)), null, null, null);
			netscape.security.PrivilegeManager.disablePrivilege("UniversalXPConnect");
			//var url = "javascript:(function(){var html=\"" + escape(replaceAds(body)) + "\"document.open();document.write(unescape(html));document.close();})();";
			//var url = "javascript:(function(){var html=\"" + "<html></html>" + "\";document.open();document.write(unescape(html));document.close();})();";
			//getDocument().location.href = url;
			*/
		} else if (isOpera()) {
			getDocument().documentElement.setAttribute("htm", body);
			getDocument().documentElement.setAttribute("sideba", sidebar);
			var url = "javascript:(function(){" + 
				"var x=document.documentElement.getAttribute('htm');" + 
				"var y=document.documentElement.getAttribute('sideba');" + 
				"document.open();document.write(x);document.close();" + 
				"document.getElementById('capitalSidebar').innerHTML = y;" +
				"})();";
			getDocument().location.href = url;
			getDocument().documentElement.setAttribute("sideba", sidebar);
			resetSidebar();
		} else {
			getDocument().close();
			getDocument().open();
			//getDocument().innerHTML = body;
			getDocument().write(body);
			getDocument().close();
			getDocument().documentElement.setAttribute("sideba", sidebar);
			resetSidebar();
		}
	}

	function resetSidebar() {
		try {
			getDocument().getElementById("capitalSidebar").innerHTML = getDocument().documentElement.getAttribute("sideba");
			if (getDocument().getElementById("capitalSidebar").innerHTML.indexOf("SciLor")==-1) {
				setTimeout(function() { resetSidebar() }, 500);
			}
		} catch (ex) {
			setTimeout(function() { resetSidebar() }, 500);
		}
	}

	function getSciLorSidebar() {
		var sidebar = getFileContent("sidebar.html");
		sidebar = sidebar.replace("{SciLorsVersion}", getVersion());
		if (isOpera() || isFirefox()) {
			sidebar = sidebar.replace("{SciLorsGrooveIcon128}", getFileContent("GrooveIcon128.base64"));
		} else {
			sidebar = sidebar.replace("{SciLorsGrooveIcon128}", getLocalUrl("GrooveIcon128.png"));
		}
		return sidebar;
	}

	function replaceAds(body) {
		body = body.replace("{SciLorsSidebar}", getSciLorSidebar());
		return body;
	}


	function getLocalUrl(file) {
		if (isChrome()) {
			return chrome.extension.getURL("includes/"+file);
		} else if (isOpera()) {
			return file;
		} else if (isFirefox()) {
			return "chrome://SciLorsGrooveUnlocker/content/"+file;
		}
	}
	function getVersion() {
		if (isChrome()) {
			return JSON.parse(getFileContent(chromeConfig))["version"];
		} else if (isOpera()) {
			return getFileXML(operaConfig).getElementsByTagName('widget').item(0).getAttribute("version");
		} else if (isFirefox()) {
			return getFileContent(firefoxConfig);
		}
	}
	function getXMLHttpRequest() {
		if (isChrome()) {
			return new XMLHttpRequest();
		} else if (isOpera()) {
			return new window.XMLHttpRequest();
			//throw "Don't use Ajax in here, need to be processed in the backgound.html!";
		} else if (isFirefox()) {
			return new XMLHttpRequest();
		}
	}


	function attachDomLoaded (callback) {
		/* Internet Explorer */
		/*@cc_on
		@if (@_win32 || @_win64)
			document.write('<script id="ieScriptLoad" defer src="//:"><\/script>');
			document.getElementById('ieScriptLoad').onreadystatechange = function() {
				if (this.readyState == 'complete') {
					callback();
				}
			};
		@end @*/
		
		/* Mozilla, Chrome, Opera */
		if (isFirefox()) {
			getAppContent().addEventListener("DOMContentLoaded", callback, true);
			return;
		} else if (document.addEventListener) {
			document.addEventListener('DOMContentLoaded', callback, false);
		} 
		if (isOpera()) {
			return;
		}
		
		/* Safari, iCab, Konqueror */
		/*
		if (/KHTML|WebKit|iCab/i.test(navigator.userAgent)) {
			var DOMLoadTimer = setInterval(function () {
				if (/loaded|complete/i.test(document.readyState)) {
					callback();
					clearInterval(DOMLoadTimer);
				}
			}, 10);
		}
		*/
		/* Other web browsers */
		window.onload = callback;
	};

	if (isOpera()) {
		opera.extension.onmessage = function(e) {
			fileData[e.data.path] = e.data;
		};
	}

	function start() {
		if (isFirefox()) {
			if (getDocument().URL.indexOf("http://grooveshark.com") < 0) {
				return;
			}
		}
		
		//if (getDocument().body.innerHTML.indexOf('SciLor')==-1) {
		if (getDocument().body.innerHTML.indexOf('GEMA')>0) {
			if (!loaded) {
				loadAllFiles();
			} else {
				waitForIp();
			}
		} else {
		
		}
	}

	function loadedAllFiles() {
		for (var i=0; i<files.length; i++) {
			var file = files[i];
			var ajax = fileData[getLocalUrl(file)];
			if (ajax == null) {
				return false;
			} else if (ajax.readyState!=4){
				return false;
			}
		}
		return true;
	}

	function loadAllFiles() {
		if (isChrome()) {
			files.push(chromeConfig);
		} else if (isOpera()) {
			files.push(operaConfig);
		}
		for (var i=0; i<files.length; i++) {
			var file = files[i];
			if (isChrome() || isFirefox()) {
				fileData[getLocalUrl(file)]=getAjaxGet(getLocalUrl(file));
			} else if (isOpera()) {
				opera.extension.postMessage({
					action: "ajax",
					path: getLocalUrl(file),
					type: "GET",
					data: null
				});
			}
		}
		
		if (isFirefox()) {
			files.push(firefoxConfig);
			var version = "";
			try {
				// Firefox 4 and later; Mozilla 2 and later
				Components.utils.import("resource://gre/modules/AddonManager.jsm");
				AddonManager.getAddonByID("SciLorsGrooveUnlocker@scilor.com", function(addon) {
					version = addon.version;
					fileData[getLocalUrl(firefoxConfig)] = { responseText: version, readyState: 4 };
				});
			} catch (ex) {
				// Firefox 3.6 and before; Mozilla 1.9.2 and before
				var em = Components.classes["@mozilla.org/extensions/manager;1"]
						 .getService(Components.interfaces.nsIExtensionManager);
				var addon = em.getItemForID("extension-guid@example.org");
				version = addon.version;
				fileData[getLocalUrl(firefoxConfig)] = { responseText: version, readyState: 4 };
			}
		}
		
		waitForFiles();
	}
	function waitForFiles() {
		if (!loadedAllFiles()) {
			setTimeout(function() { waitForFiles() }, 1000);		
			return;
		} 
		
		if (isOpera()) {
			for (var i=0; i<files.length; i++) {
				var file = files[i];
				try {
					var dom = new window.DOMParser();
					fileData[getLocalUrl(file)].responseXML = dom.parseFromString(
						getFileContent(file),
						"text/xml"
					);
				} catch (e) { }
			}
		}
		
		initiateSession();
	}

	function getFileContent(path) {
		return fileData[getLocalUrl(path)].responseText;
	}
	function getUrlContent(url) {
		return fileData[url].responseText;
	}
	function getFileXML(path) {
		return fileData[getLocalUrl(path)].responseXML;
	}
			
	function initiateSession() {
		if (!downloadGrooveshark) { //Use Local grooveshark.html
			var grooveFix = getFileXML("GrooveFix.xml");
			var htmlshark = grooveFix.getElementsByTagName('htmlshark').item(0);
			var client = htmlshark.getElementsByTagName('GrooveClient').item(0).firstChild.nodeValue;
			var clientRevision = htmlshark.getElementsByTagName('GrooveClientRevision').item(0).firstChild.nodeValue;
			var sessionParam = getFileContent("initiateSession.json");

			sessionParam = sessionParam.replace("{SciLorsGroovesharkUUID}", uuid);
			sessionParam = sessionParam.replace("{SciLorsClient}", client);
			sessionParam = sessionParam.replace("{SciLorsClientRevision}", clientRevision);
			if (isChrome() || isFirefox() || isOpera()) {
				fileData[sessionUrl] = getAjaxPost(sessionUrl, sessionParam);
			} 
			waitForSession();
		} else {
			if (!isOpera()) {
				fileData[groovesharkIp] = getAjaxGet(groovesharkIp, sessionParam);
			} else {
				opera.extension.postMessage({
					action: "ajax",
					path: groovesharkIp,
					type: "GET",
					data: null
				});
			}
			waitForIp();
		}
	}
	function waitForIp() {
		if (fileData[groovesharkIp] == null || fileData[groovesharkIp].readyState!=4 || fileData[groovesharkIp].status!=200){
			setTimeout(function() { waitForIp() }, 100);		
			return;
		}
		loaded = true;
		overwriteHtml(getUrlContent(groovesharkIp));
	}

	function waitForSession() {
		if (fileData[sessionUrl] == null || fileData[sessionUrl].readyState!=4 || fileData[sessionUrl].status!=200) {
			setTimeout(function() { waitForSession() }, 100);		
			return;
		}
		
		var session = JSON.parse(getUrlContent(sessionUrl))["result"];
		var html = getFileContent("grooveshark.html");
		html = html.replace("{SciLorsGroovesharkUUID}", uuid);
		html = html.replace("{SciLorsGroovesharkSession}", session);
		overwriteHtml(html);	
	}

	function getAjax(path, type, data) {
		var ajax = getXMLHttpRequest();
		ajax.open(type, path, false);
		if (type=="POST") {
			ajax.send(data);
		} else {
			ajax.send();
		}
		return ajax;
	}
	function getAjaxGet(path) {
		return getAjax(path, "GET", null);
	}
	function getAjaxPost(path, data) {
		return getAjax(path, "POST", data);
	}

	//Source: http://p2p.wrox.com/topicindex/20339.htm
	function guidGenerator() {
		var S4 = function () {
			return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
		};
		return (S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4());
	}
	
	
	this.reAttachDom  = function() {
		attachDomLoaded(start);
    };

  };
}
SciLorsGrooveUnlocker.reAttachDom();